
# -------------------------------------------------------- Adding CICD Workflow ------------------------------------------------------------#
workflow:
  rules:
    - if: $CI_COMMIT_BRANCH != "main" && $CI_PIPELINE_SOURCE != "merge_request_event"
      when: never
    - when: always

# -------------------------------------------------------- Adding Stages ------------------------------------------------------------#
stages:
  - test
  - build
  - deploy

# -------------------------------------------------------- Adding Stages ------------------------------------------------------------#
variables:
  DEPLOYMENT_SERVER_HOST: ubuntu
  DEPLOYMENT_SERVER_IP: "172.31.60.17"
  APP_ENDPOINT: http://ec2-18-234-130-65.compute-1.amazonaws.com:3000

# -------------------------------------------------------- Adding SAST Testing provided by Gitlab ------------------------------------------------------------#
sast:
  stage: test
include:
  - template: Security/SAST.gitlab-ci.yml

# -------------------------------------------------------- Template for Building Images for each microservices ------------------------------------------------------------#
.build:
  stage: build
  tags:
    - shell-runner
  variables:
    MICRO_SERVICE: ""
    SERVICE_VERSION: ""
  before_script:
    - cd $MICRO_SERVICE
    - export IMAGE_NAME=$CI_REGISTRY_IMAGE/$MICRO_SERVICE
    - export IMAGE_TAG=$SERVICE_VERSION
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker build -t $IMAGE_NAME:$IMAGE_TAG .
    - docker push $IMAGE_NAME:$IMAGE_TAG

# ------------------------------------------------ Building and Pushing Images for frontend microservice using template -----------------------------------#
build_frontend:
  extends: .build
  variables:
    MICRO_SERVICE: frontend
    SERVICE_VERSION: "1.3"
  only:
    changes:
      - "frontend/**/*"

# ------------------------------------------------ Building and Pushing Images for products microservice using template -----------------------------------#
build_products:
  extends: .build
  variables:
    MICRO_SERVICE: products
    SERVICE_VERSION: "1.8"
  only:
    changes:
      - "products/**/*"

# ------------------------------------------------ Building and Pushing Images for shopping-cart microservice using template -----------------------------------#
build_shopping_cart:
  extends: .build
  variables:
    MICRO_SERVICE: shopping-cart
    SERVICE_VERSION: "2.1"
  only:
    changes:
      - "shopping-cart/**/*"

# -------------------------------------------------------- Template for Deploying Images for each microservices ------------------------------------------------------------#
.deploy:
  stage: deploy
  tags:
    - shell-runner
  variables: 
    MICRO_SERVICE: ""
    SERVICE_VERSION: ""
    APP_PORT: ""
  before_script:
    - chmod 400 $SSH_PRIVATE_KEY
    - export IMAGE_NAME=$CI_REGISTRY_IMAGE/$MICRO_SERVICE
    - export IMAGE_TAG=$SERVICE_VERSION
  script:
    - scp -o StrictHostKeyChecking=no -i $SSH_PRIVATE_KEY ./docker-compose.yaml $DEPLOYMENT_SERVER_HOST@$DEPLOYMENT_SERVER_IP:/home/ubuntu
    - ssh -o StrictHostKeyChecking=no -i $SSH_PRIVATE_KEY $DEPLOYMENT_SERVER_HOST@$DEPLOYMENT_SERVER_IP "
      docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY &&

      export COMPOSE_PROJECT_NAME=$MICRO_SERVICE &&
      export DC_IMAGE_NAME=$IMAGE_NAME &&
      export DC_IMAGE_TAG=$IMAGE_TAG &&
      export DC_APP_PORT=$APP_PORT &&

      docker network create micro_service || true &&

      docker-compose down &&
      docker-compose up -d"
  environment:
    name: development
    url: $APP_ENDPOINT

# ------------------------------------------------ Deploy Images of frontend microservice using template -----------------------------------#
deploy_frontend:
  extends: .deploy
  variables:
    MICRO_SERVICE: frontend
    SERVICE_VERSION: "1.3"
    APP_PORT: 3000
  only:
    changes:
      - "frontend/**/*"

# ------------------------------------------------ Deploy Images of products microservice using template -----------------------------------#
deploy_products:
  extends: .deploy
  variables:
    MICRO_SERVICE: products
    SERVICE_VERSION: "1.8"
    APP_PORT: 3001
  only:
    changes:
      - "products/**/*"

# ------------------------------------------------ Deploy Images of shopping_cart microservice using template -----------------------------------#
deploy_shopping_cart:
  extends: .deploy
  variables:
    MICRO_SERVICE: shopping-cart
    SERVICE_VERSION: "2.1"
    APP_PORT: 3002
  only:
    changes:
      - "shopping-cart/**/*"







